
#include "ell/SC_Timed.hh"

namespace ell {

SC_TimedOutstream::SC_TimedOutstream(std::ostream& outStream)
	: 	out(outStream),
		stateCount(0),
		lastState(NULL),
		lastTime(0)
{}

SC_TimedOutstream::~SC_TimedOutstream() {
}

void

SC_TimedOutstream::add(const State& s) {
	out 	<< s.toString() << " "
			<< s.getEnergy()
			<< std::endl;
	lastState = s.clone(lastState);
	stateCount++;
}

void
SC_TimedOutstream::add(const State& s, const double endTime) {
	out 	<< s.toString() << " "
			<< s.getEnergy() << " "
			<< endTime
			<< std::endl;
	lastState = s.clone(lastState);
	lastTime = endTime;
	stateCount++;
}

size_t
SC_TimedOutstream::size() const {
	return stateCount;
}

const State* const
SC_TimedOutstream::getLastAdded() const {
	return lastState;
}

double
SC_TimedOutstream::getLastTime() const {
	return lastTime;
}

}
